---
title: Install
description: Overview of Pose for Vue's installation options.
category: vue
next: vue-get-started
---

# Install

<TOC />

## Package managers (recommended)

### npm

```bash
npm install vue-pose --save
```

### yarn

```bash
yarn add vue-pose
```

## File include

**Note:** The Pose documentation uses the `import` syntax for importing individual modules.

**If you use one of the following installation methods, top-level Pose for Vue exports will be available as the global `posed` variable.**

So, when you see in the docs `import posed from 'vue-pose'`, you can instead simply use the global `posed` variable.

### Download

You can download the latest version of Pose for Vue at https://unpkg.com/vue-pose/dist/vue-pose.js

### Script include

You can include it in your HTML with this `script` tag:

```
<script src="https://unpkg.com/vue-pose/dist/vue-pose.js"></script>
```

## CodeSandbox

You can fork the [Pose for Vue playground on CodeSandbox](https://codesandbox.io/s/74471lpxqx), which is set up with the latest version of Pose for Vue.
